--- old/usr/src/uts/i86pc/io/pcplusmp/apic.c	Thu Sep  7 15:25:32 2017
+++ new/usr/src/uts/i86pc/io/pcplusmp/apic.c	Thu Sep  7 15:25:32 2017
@@ -108,6 +108,8 @@
 static int		apic_get_ipivect(int ipl, int type);
 static void	apic_post_cyclic_setup(void *arg);
 
+#define	UCHAR_MAX	UINT8_MAX
+
 /*
  * The following vector assignments influence the value of ipltopri and
  * vectortoipl. Note that vectors 0 - 0x1f are not used. We can program
@@ -1068,7 +1070,7 @@
 {
 	int	rcount, i;
 	uchar_t	start, irqno;
-	uint32_t cpu;
+	uint32_t cpu = 0;
 	major_t	major;
 	apic_irq_t	*irqptr;
 
@@ -1140,7 +1142,8 @@
 		irqptr->airq_vector = (uchar_t)(start + i);
 		irqptr->airq_ioapicindex = (uchar_t)inum;	/* start */
 		irqptr->airq_intin_no = (uchar_t)rcount;
-		irqptr->airq_ipl = pri;
+		ASSERT(pri >= 0 && pri <= UCHAR_MAX);
+		irqptr->airq_ipl = (uchar_t)pri;
 		irqptr->airq_vector = start + i;
 		irqptr->airq_origirq = (uchar_t)(inum + i);
 		irqptr->airq_share_id = 0;
@@ -1217,7 +1220,8 @@
 		apic_min_device_irq = min(irqno, apic_min_device_irq);
 		irqptr = apic_irq_table[irqno];
 		irqptr->airq_vector = (uchar_t)vector;
-		irqptr->airq_ipl = pri;
+		ASSERT(pri >= 0 && pri <= UCHAR_MAX);
+		irqptr->airq_ipl = (uchar_t)pri;
 		irqptr->airq_origirq = (uchar_t)(inum + i);
 		irqptr->airq_share_id = 0;
 		irqptr->airq_mps_intr_index = MSIX_INDEX;
@@ -1259,7 +1263,8 @@
 			continue;
 		if (apic_vector_to_irq[i] == APIC_RESV_IRQ) {
 			apic_vector_to_irq[i] = (uchar_t)irq;
-			return (i);
+			ASSERT(i >= 0 && i <= UCHAR_MAX);
+			return ((uchar_t)i);
 		}
 	}
 
